from HTTPfetcher import *
from TableContents import *
import threading


class tableThread(threading.Thread):
    res=""
    def __init__ ( self,DASUrl, content):
      self.table=Table(DASUrl,content)
      threading.Thread.__init__ ( self )
    
    def run(self):
      try:
       self.res=self.table.getTableCode()
      except ConnectionException, e:
       print e 
       self.res=""
 
    def getHTML(self):
        return self.res
      
      
################################################################
class Table(object):
   """
This class can fetch the data from DAS and format a HTML table based on the received data
   """ 
   name='generic'
   #tableStepSize=10
   #title="Table Title"
   #colDecorators=[]
   
   def __init__(self,DASUrl,content):
    try:
      self.DASUrl=DASUrl
      self.content=content
    except:
        print "Table init error!!"
    #fetch information: used only for 1 table
    url=self.DASUrl+ content.URL
    if len(self.content.URL)>0: 
        f= HTTPfetcher(url)
        self.data=f.fetchUrl()

   def getData(self):
     return self.data

   
   
   def getTableCode(self,data={}):
      """
      HTML Code generation for the fetched data [data may be passed as parameter]
      """
      if data=={}: data=self.data
      tableTop="""<table border="0" cellspacing="2">
                  <tbody><tr><th colspan=" """+str(len(self.content.colDecorators)) +""""  align="center" > """ +self.content.title+"""</th></tr>"""
      tableTop+="<tr>"
      for c in self.content.colDecorators:
         tableTop+="""<td style="background-color: rgb(185, 208, 222);"> """+c.colName+"</td>"
      tableTop+="</tr>"
      
      bkground=""   
      tableBody=""
      for line in data:
         #print "line="+str(v)
         tableBody+="<tr>"
         if bkground=="": bkground=""" style="background-color: white;" """
         else: bkground=""
         for col in self.content.colDecorators:
           try: 
            values=[]
            for attr in col.attrNames:
              values.append(str(line[attr]))
            if hasattr(col,'getAuxInfo'):  # graphs need more information: specific ones for every run
              values+=col.getAuxInfo(self,line)
            #print "VALUES="+str(values)
            tableBody+="<td"+bkground+">"+col.decorator(values)+"</td>"
           except Exception, e:
              print "Exception: "+str(e) +"  "+str(line)
              tableBody+="<td"+bkground+">"+"No column attribute found"+"</td>"    
         tableBody+="</tr>"
      ## links must be added ONLY if the table is a "long" one
      if self.content.isLongTable:
         tableBody+=self.getLinks(data)
      tableBody+="</tbody></table>"   
      return tableTop+tableBody

   def getLinks(self,data):
        ## set up  next/prevous page links for longTables
        options=""
        try:
            #print "RUN="+str(self.content.run)
            if self.content.run>0:
             options="&run_id="+str(self.content.run)
        except Exception, e:
            #print e
            options=""
        try:
            if len(self.content.status)>0:
             options+="&status="+str(self.content.status)
        except:
            pass
        #print "options=="+options
        
        linksCode="""<tr><td style="background-color: rgb(185, 208, 222);" colspan=" """+str(len(self.content.colDecorators)) +""""  align="center" >"""
        linksCode+="<div id=\""+self.content.name+"links\">"
        contentName=self.content.name
        if self.content.page>1:
           linksCode+=" <a href=\"javascript:loadXMLDoc('"+self.content.name+"','single?table="+contentName+"&page="+str(self.content.page-1)+options+"','"+self.content.name+"links')\">Previous Values</a>&nbsp;&nbsp;&nbsp; "
        linksCode+="&nbsp;&nbsp; ---"+ "<a href=\"javascript:loadXMLDoc('"+self.content.name+"','single?table="+contentName+"&page="+str(self.content.page)+options+"','"+self.content.name+"links')\" title=\"Refresh\">"+"Page # "+str(self.content.page)+"</a>--- &nbsp;&nbsp;"
        if len(data)>=self.content.tableStepSize:
           linksCode+="&nbsp;&nbsp; <a href=\"javascript:loadXMLDoc('"+self.content.name+"','single?table="+contentName+"&page="+str(self.content.page+1)+options+"','"+self.content.name+"links')\">Next Values</a>"
        linksCode+="</div></td></tr>"
        return linksCode
        
  