from Table import *
from Columns import *


class content(object):
  """
This class represent the SuperClass of every table content information.
Every table may have different title/URL and columns!
The __init__ method is also used to set the page attribute: in long table this decide the limits of the data
The 'name' of the content MUST be the same of the class [__class__.__name__]
  """ 
  page=1
  suffix=""
  colDecorators=[]
  title=""
  linkPage=""
  isLongTable=False
  tableStepSize=10
  
  def __init__(self,params={}):
    #self.tableStepSize=tableStepSize
    self.downLimit =0 
    self.upLimit  = self.tableStepSize
    self.run=0
    #print "PARAMS:"+str(params) + str(self.name ) 
    try:
       #print "PARAMS:"+str(params) + str(self.name )
       if str(params['table']) ==self.name:
         #if more values of ['table'] this is ignored.
         try:
            self.run=int(params['run_id'])
         except:
            self.run=0
         try:
           self.page=int(params['page'])
           if (self.page<1):self.page=1
           self.downLimit =(self.page -1) * self.tableStepSize 
           self.upLimit=self.downLimit+self.tableStepSize
         except:
           self.downLimit =0 
           self.upLimit  = self.tableStepSize
         try:
            self.status=params['status']
         except:
           pass
        
    except Exception, e:
       #print str(e)
       pass
    self.updateLinks()  
           
  def updateLinks(self):
      pass



class longTableByRunContent(content):
   isLongTable=True
   linkPage=""
   forceRunParameter=False
   
   def updateLinks(self):
       if self.run>0:
           self.URL+="?run="+str(self.run)+'&'
       elif self.forceRunParameter:
           self.URL+='?run=&'
       else: self.URL+='?'
       self.URL+="uplimit="+str(self.upLimit) +'&downlimit='+str(self.downLimit)
       try:
         self.URL+="&status="+self.status
         self.title=self.title%(self.status)
       except Exception, e:
         #print str(e)
         pass
       

############################################ main page tables

class exprJ(longTableByRunContent):
  name='exprJ'
  #CSSclass='expressBG'
  URL='expressnewusedjobs'
  title="Express New and Used Jobs"
  path='history?source=Express'
  colDecorators=[JobId(path),RunId(),defTime(),nstreamers()]
  isLongTable=True

class exprMJ(longTableByRunContent):
  name='exprMJ'
  #CSSclass='expressBG'
  URL='expressmergelastjobs'
  title="Express Merge Acquired Jobs"
  path='history?source=ExpressMerge'
  colDecorators=[JobId(path),RunId(),defTime(),filesNum()]
  isLongTable=True  
    
class repkJ(longTableByRunContent):
  name='repkJ'
  #CSSclass='repackBG'
  URL='repacklastacquired'
  title="Repack running Jobs"
  path='history?source=Repack'
  colDecorators=[JobId(path),RunId(),runTime(attrNames=["def_time"]),nstreamers(),stream()]
  isLongTable=True
  
class repkMJ(longTableByRunContent):
  name='repkMJ'
  #CSSclass='repackBG'
  URL='repackmergelastacquired'
  title="Repack Merge Acquired Jobs"
  path='history?source=RepackMerge'
  colDecorators=[JobId(path),RunId(),defTime(attrNames=["state_time"]),filesNum(),dataset()]
  isLongTable=True  
  
class recoJ(longTableByRunContent):
  name='recoJ'
  #CSSclass='recoBG'
  URL='recolastacquired'
  title="Reconstruction Acquired Jobs"
  path='history?source=Reco'
  colDecorators=[JobId(path),RunId(),defTime(attrNames=["state_time"]),filesNum(),dataset()]
  isLongTable=True
  
class recoMJ(longTableByRunContent):
  name='recoMJ'
  #CSSclass='recoBG'
  URL='recomergelastacquired'
  title="Reco Merge Acquired Jobs"
  path='history?source=RecoMerge'
  colDecorators=[JobId(path),RunId(),defTime(attrNames=["state_time"]),filesNum(),dataset()]
  isLongTable=True
    
class alcaJ(longTableByRunContent):
  name='alcaJ'
  #CSSclass='alcaBG'
  URL='alcalastacquired'
  title="Alcaskim Acquired Jobs"
  path='history?source=Alca'
  colDecorators=[JobId(path),RunId(),defTime(attrNames=["state_time"]),filesNum(),dataset()]
  isLongTable=True
  
class alcaMJ(longTableByRunContent):
  name='alcaMJ'
  #CSSclass='alcaBG'
  URL='alcamergelastacquired'
  title="AlcaSkim Merge Acquired Jobs"
  path='history?source=AlcaMerge'
  colDecorators=[JobId(path),RunId(),defTime(attrNames=["state_time"]),filesNum(),dataset()]
  isLongTable=True
    
################################################################################ detail tables

class exprJByStatus(exprJ):
  name='exprJByStatus'
  URL='expressjobsbystatus'
  title="Express %s Jobs"
  forceRunParameter=True
  tableStepSize=100
  
class exprMJByStatus(exprMJ):
  name='exprMJByStatus'
  URL='expressmergejobsbystatus'
  title="Express Merge %s Jobs"  
  colDecorators=[JobId(path='history?source=ExpressMerge'),RunId(),defTime(attrNames=["state_time"]),filesNum()]
  forceRunParameter=True
  tableStepSize=100  
  
class repkJByStatus(repkJ):
  name='repkJByStatus'
  URL='repackjobsbystatus'
  title="Repack %s Jobs"
  forceRunParameter=True
  tableStepSize=100
 
  
class repkMJByStatus(repkMJ):
  name='repkMJByStatus'
  URL='repackmergejobsbystatus'
  title="Repack Merge %s Jobs"
  forceRunParameter=True
  tableStepSize=100

  
class recoJByStatus(recoJ):
  name='recoJByStatus'
  URL='recojobsbystatus'
  title="Reconstruction %s Jobs"
  forceRunParameter=True
  tableStepSize=100
  
class recoMJByStatus(recoMJ):
  name='recoMJByStatus'
  URL='recomergejobsbystatus'
  title="Reco Merge %s Jobs"
  forceRunParameter=True
  tableStepSize=100
    
class alcaJByStatus(alcaJ):
  name='alcaJByStatus'
  URL='alcajobsbystatus'
  title="Alcaskim %s Jobs"
  forceRunParameter=True
  tableStepSize=100
  
class alcaMJByStatus(alcaMJ):
  name='alcaMJByStatus'
  URL='alcamergejobsbystatus'
  title="AlcaSkim Merge %s Jobs"
  forceRunParameter=True
  tableStepSize=100
  
########################################### run page tables

###########################################################configuration
class configuration(content):
   URL=""
   isLongTable=False
   def updateLinks(self):
       self.URL=self.URL%(str(self.run))
       
class ExpressConfig(configuration):
  name="ExpressConfig"
  title="Express Configuration"
  URL="express_config?run=%s&stream="
  colDecorators=[stream(),splitInProgress(),procVersion(),confUrl(),globalTag(),AMConfUrl()]

class GeneralConfig(configuration):
  name="GeneralConfig"
  title="Global Configuration" 
  URL="general_config?run=%s"
  colDecorators=[dataset(),rpProcVersion(),roReco(),roCmsswVersion(),roGlobalTag(),roConfUrl(),roProcVersion(),alAlcaskim(),alCmsswVersion(),alConfUrl(),alProcVersion()]

#####################################################################

class streamers(longTableByRunContent):
  name='streamers'
  #CSSclass='expressBG'
  URL='runstreamers'
  title="Streamers files"
  path='history?source=Streamer'
  colDecorators=[StreamerId(path),lumiId(),filesize(),events(),stream(),lfn()]
  
  #BUG FIX: deleted exportable() column
  
class exprTF(longTableByRunContent):
  name='exprTF'
  #CSSclass='expressBG'
  URL='runtempexpressfiles'
  title="Temporary Express files"
  path='history?source=Express'
  colDecorators=[FileId(path),filesize(),events(),lfn()]
  
class exprF(longTableByRunContent):
  name='exprF'
  #CSSclass='expressBG'
  URL='runexpressfiles'
  title="Express Files"
  path='history?source=ExpressMerge'
  colDecorators=[FileId(path),filesize(),events(),lfn()]  
  isLongTable=True
    
class repkTF(longTableByRunContent):
  name='repkTF'
  #CSSclass='repackBG'
  URL='runtemprepackfiles'
  title="Temporary Repack files"
  path='history?source=Repack'
  colDecorators=[FileId(path),filesize(),events(),dataset(),lfn()]
  isLongTable=True
  
class repkF(longTableByRunContent):
  name='repkF'
  #CSSclass='repackBG'
  URL='runrepackfiles'
  title=" Repack files"
  path='history?source=RepackMerge'
  colDecorators=[FileId(path),filesize(),events(),dataset(),lfn()]
  isLongTable=True 
  
class recoTF(longTableByRunContent):
  name='recoTF'
  #CSSclass='recoBG'
  URL='runtemprecofiles'
  title="Temporary Reconstruction Files"
  path='history?source=Reco'
  colDecorators=[FileId(path),filesize(),events(),tier(),dataset(),lfn()]
  isLongTable=True
  
class recoF(longTableByRunContent):
  name='recoF'
  #CSSclass='recoBG'
  URL='runrecofiles'
  title="Reconstruction Files"
  path='history?source=RecoMerge'
  colDecorators=[FileId(path),filesize(),events(),dataset(),lfn()]
  isLongTable=True
    
class alcaTF(longTableByRunContent):
  name='alcaTF'
  #CSSclass='alcaBG'
  URL='runtempalcafiles'
  title="Temporary Alcaskim Files"
  path='history?source=Alca'
  colDecorators=[FileId(path),filesize(),events(),dataset(),skim(),lfn()]
  isLongTable=True
  
class alcaF(longTableByRunContent):
  name='alcaF'
  #CSSclass='alcaBG'
  URL='runalcafiles'
  title="AlcaSkim Files"
  path='history?source=AlcaMerge'
  colDecorators=[FileId(path),filesize(),events(),dataset(),skim(),lfn()]
  isLongTable=True

############################################################################ History tables
    
class HStreamerFiles(streamers):
  title="Streamers"

#############################
class HExpressJobs(exprJ):
  title=" Express Jobs"

class HExpressFiles(exprF):
  path='history?source=Express'
  title="Temporary Express Files"
  colDecorators=[FileId(path),filesize(),events(),lfn()]

class HExpressMergeJobs(exprMJ):
  title=" Express Merge Jobs"

class HExpressMergeFiles(exprTF):
  path='history?source=ExpressMerge'
  title=" Express Files"
  colDecorators=[FileId(path),filesize(),events(),lfn()]
  
#############################
class HRepackJobs(content):
  title=" Repack Jobs"
  path='history?source=Repack'
  colDecorators=[JobId(path),RunId(),defTime(),nstreamers(),stream(),status()]
  
class HRepackFiles(content):
  path='history?source=Repack'
  title="Temporary Repack Files"
  colDecorators=[FileId(path),filesize(),events(),dataset(),lfn()]


class HRepackMergeJobs(content):
  title=" Repack Merge Jobs"
  path='history?source=RepackMerge'
  colDecorators=[JobId(path),RunId(),filesNum(),dataset()]  
  
class HRepackMergeFiles(content):
  path='history?source=RepackMerge'
  title="Repack Files"
  colDecorators=[FileId(path),filesize(),events(),dataset(),lfn()]
#############################
class HRecoJobs(content):
  title=" Reco Jobs"
  path='history?source=Reco'
  colDecorators=[JobId(path),RunId(),defTime(),filesNum(),dataset()]
  
class HRecoFiles(content):
  path='history?source=Reco'
  title="Temporary Reco Files"
  colDecorators=[FileId(path),filesize(),events(),tier(),dataset(),lfn()]


class HRecoMergeJobs(content):
  title=" Reco Merge Jobs"
  path='history?source=RecoMerge'
  colDecorators=[JobId(path),RunId(),defTime(),filesNum(),dataset()]  
  
class HRecoMergeFiles(content):
  path='history?source=RecoMerge'
  title=" Reco Files "
  colDecorators=[FileId(path),filesize(),events(),dataset(),lfn()]
#############################
class HAlcaJobs(content):
  title=" Alca Jobs"
  path='history?source=Alca'
  colDecorators=[JobId(path),RunId(),defTime(),filesNum(),dataset()]
  
class HAlcaFiles(content):
  path='history?source=Alca'
  title="Temporary Alca Files"
  colDecorators=[FileId(path),filesize(),events(),skim(),dataset(),lfn()]


class HAlcaMergeJobs(content):
  title=" Alca Merge Jobs"
  path='history?source=AlcaMerge'
  colDecorators=[JobId(path),RunId(),defTime(),filesNum(),skim(),dataset()]  
  
class HAlcaMergeFiles(content):
  path='history?source=AlcaMerge'
  title=" Alca Files"
  colDecorators=[FileId(path),filesize(),events(),skim(),dataset(),lfn()]
#########################################################################################################################
### STATISTICS!!
class statTable(object):
  title="Table"
  attrStatus="status"
  attrCount="count"
  URL=""
  tableNames=["acquired", "complete", "failed"]
  
    

class expressTable(statTable):
  title="Express stats"
  URL="statsexpress?run=%s"
  link="detail?table=exprJByStatus&run_id=%s&status=%s"
  
class repackTable(statTable):
  title="Repack stats"
  URL="statsrepack?run=%s"
  link="detail?table=repkJByStatus&run_id=%s&status=%s" 
     
     
class expressMergeTable(statTable):
  title="Express Merge stats"
  #URL="statsexpressmerge?run=%s&table=%s"
  URL="statsexpressmerge?run=%s"
  link="detail?table=exprMJByStatus&run_id=%s&status=%s"
  
class repackMergeTable(statTable):
  title="Repack Merge stats"
  URL="statsrepackmerge?run=%s"
  link="detail?table=repkMJByStatus&run_id=%s&status=%s"
  
class recoTable(statTable):
  title="Reco stats"
  URL="statsreco?run=%s"
  link="detail?table=recoJByStatus&run_id=%s&status=%s" 

class recoMergeTable(statTable):
  title="Reco Merge stats"
  URL="statsrecomerge?run=%s"
  link="detail?table=recoMJByStatus&run_id=%s&status=%s"
  
class alcaTable(statTable):
  title="AlcaSkim stats"
  URL="statsalca?run=%s"
  link="detail?table=alcaJByStatus&run_id=%s&status=%s" 

class alcaMergeTable(statTable):
  title="AlcaSkim Merge stats"
  URL="statsalcamerge?run=%s"
  link="detail?table=alcaMJByStatus&run_id=%s&status=%s" 